/************************************************
File name    : keylock.c
Complier     : Franklin C51
Editor       : JOHN CHENG
Date         : 12-DEC-95
*************************************************/
#include "keylock.h"
#include "delay.c"

/*#define abc dbyte  [0x20]
*/
#define StartValue (65536-50000)

byte RowCount,DelayCount,DigitCount,ErrorCount;
byte UserKey[3];
byte SuperKey[3];
byte KeyData[3];
bit ClearFlag;
bit UserFlag;

void Timer0(void) interrupt 1 using 1
{
	   TL0 = StartValue %256;
	   TH0 = StartValue /256;
	   DelayCount++;
	while (DelayCount >= 10)
	   {
		 DelayCount = 0;
		 DigitCount = 0;
		 /* Disable timer 0*/
		 TR0 = 0;
	   }
}

void Initial(void)
{
   bit ACK;
   byte Count;
   TMOD = 0x01;
   IE = 0x082;
   RowCount = 0x0EE;
   DigitCount = 0;
   P3 =0x0FF;
	Count = 0;
   while ( Count < 3 )
   {
	if ((ACK=Start(DeviceAdd,0)) ==1 )
	 {
	   Stop();
	   Count++;
	 }
	else Count = 4;
   }

   if ( ACK == 1 ) Buzzer = 0 ;
	 
   else
	{
	 ACK = Start( 0x00, 1 );

	 for ( Count = 0 ; Count < 3 ; Count++ )
	  {
		UserKey[Count] = Read();
	  }
	 for (Count = 0 ; Count < 3 ; Count++)
	  {
		SuperKey[Count] = Read();
	  }
	Stop();
	}
}


byte ReadKey(void)
{
   byte TempRead;
   RowCount = (RowCount << 1 ) ;
   P1 = (RowCount | 0x0F0 );
   Delay(1);
   TempRead = P1 ;
   while ( P1 < 0x0F0 )
	{
	   Buzzer = 0;
	   Delay(1);
	   Buzzer = 1 ;
		while ( P1 < 0x0F0 ) ;

	  TL0 = StartValue % 256 ;
	  TH0 = StartValue / 256 ;
	  TR0 = 1 ;
	  DelayCount = 0 ;
	}
	return(TempRead);
}

void Decode(byte Temp)
{
  if ( Temp <= 0xEE )
	{
	  ClearFlag = 1;
	  DigitCount = 0;
	}
   else
	{
	 KeyData[DigitCount] = Temp;
	}
}

void Compare(void)
{
   if ((strncmp(SuperKey,KeyData,3)) == 0 ) UserFlag = 1;
   else if ((strncmp(UserKey,KeyData,3)) == 0 )
	 {
	   UserFlag = 0 ;
	   Relay = 0 ;
	   Delay(300);
	   Relay = 1;
	   ErrorCount = 0 ;
	 }
	else
	 {
	   ErrorCount++;
	   while (ErrorCount >= 3)
		{
		   ErrorCount = 0 ;
		   Delay(3000);
		}
	 }
}

bit Backup(byte Address)
{
	byte i;    
	bit ACK;
	 ACK=Start(DeviceAdd,0);
	  ACK = (ACK | Write(Address));
		 for(i=0; i<3; i++)
		  {
			ACK = (ACK | Write(KeyData[i]));  
		  }
		Stop();
	 return(ACK);
} 

void main(void)
{
  byte Temp;
  Initial();
   while (1)
	{
	while((Temp=ReadKey()) < 0x0F0 )
	 {
	   Decode(Temp);
	   while (DigitCount == 3 )
		{
		  DigitCount = 0 ;
		  if (ClearFlag == 1 )
		   {
			if(Backup(SuperAddress) == 1 ) Buzzer = 0 ;
			 for (Temp = 0; Temp<3; Temp++)
			  {
				 SuperKey[Temp] = KeyData[Temp];
			  }
			  UserFlag = 1 ;
			  ClearFlag = 0;
		   }
		  else if (UserFlag == 1 )
			{
			 if (Backup(UserAddress) == 1 ) Buzzer = 0;
			  for (Temp = 0; Temp<3; Temp++)
				UserKey[Temp] = KeyData[Temp];
			  ClearFlag = 0;
			}
		  else
		   {
			Compare();
		   }
		}
	 }

	}
}
